package zero1hd.polyjet.ui.builders;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Preferences;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;

public class SetResolutionButton extends TextButton {
	
	public SetResolutionButton(final int width, final int height, Skin skin, final Preferences prefs) {
		super(width + "x" + height, skin);
		
		addListener(new ChangeListener() {
			
			@Override
			public void changed(ChangeEvent event, Actor actor) {
				Gdx.graphics.setWindowedMode(width, height);
				prefs.putInteger("screen-width", width);
				prefs.putInteger("screen-height", height);
				prefs.putBoolean("fullscreen", false);
				prefs.flush();
			}
		});
	}
}
